unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, StdCtrls,
  ExtCtrls, Jpeg, IdAntiFreezeBase, IdAntiFreeze, IdCustomTCPServer,
  IdTCPServer, IdContext, inifiles, ShellAPI, ComCtrls, MMSystem;

const
  WM_ICONTRAY = WM_USER + 1;

type
  TForm1 = class(TForm)
    IdTCPClient1: TIdTCPClient;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    Button2: TButton;
    IdTCPServer1: TIdTCPServer;
    Memo1: TMemo;
    Button3: TButton;
    ProgressBar1: TProgressBar;
    Label1: TLabel;
    Timer1: TTimer;
    Label2: TLabel;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure IdTCPServer1Execute(AContext: TIdContext);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TrayMessage(var Msg: TMessage);
    message WM_ICONTRAY;
    procedure IdTCPClient1Work(ASender: TObject; AWorkMode: TWorkMode;
      AWorkCount: Int64);
    procedure IdTCPClient1Disconnected(Sender: TObject);
    procedure IdTCPClient1WorkEnd(ASender: TObject; AWorkMode: TWorkMode);
    procedure IdTCPClient1WorkBegin(ASender: TObject; AWorkMode: TWorkMode;
      AWorkCountMax: Int64);
    procedure  IdTCPServer1Work(ASender: TObject; AWorkMode: TWorkMode; AWorkCount: Int64);
    function PlaySound(Sound: string): string;
    procedure Button4Click(Sender: TObject);
    procedure AcceptFiles( var msg : TMessage );
      message WM_DROPFILES;
  private
    TrayIconData: TNotifyIconData;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  IP: string;
  PORT, PORT_SERVER: integer;
  NAZOV_PRIECINKU: string;
  Thread: TThread;
  SUBOR: string;
  CISLO: integer;
  SUBOR_VELKOST_ORIGINAL: integer;

implementation

  uses Unit2;

{$R *.dfm}

type
  TThreadThread = class(TThread)
  protected
    procedure Execute; override;
  end;


function TForm1.PlaySound(Sound: string): string;
var
  WinPath: array[0..MAX_PATH + 1] of char;
  Cesta: PWideChar;
begin
  GetWindowsDirectory(WinPath,MAX_PATH);
  Cesta := PWideChar(WinPath + '\Media\' + Sound);
  sndPlaySound(Cesta, SND_ASYNC);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Thread := TThreadThread.Create(False);
end;


procedure TForm1.AcceptFiles( var msg : TMessage );
const
  cnMaxFileNameLen = 255;
var
  i,
  nCount     : integer;
  acFileName : array [0..cnMaxFileNameLen] of char;
begin
  // find out how many files we're accepting
  nCount := DragQueryFile( msg.WParam,
                           $FFFFFFFF,
                           acFileName,
                           cnMaxFileNameLen );

  // query Windows one at a time for the file name
  if (nCount) <= 1 then
  begin
    DragQueryFile( msg.WParam, 0,
                   acFileName, cnMaxFileNameLen );

    // do your thing with the acFileName
    if FileExists(acFileName) then
    begin
      OpenDialog1.FileName := acFileName;
      Thread := TThreadThread.Create(False);
    end
    else if DirectoryExists(acFileName) then
      MessageBox(0, 'Priecinok sa neda poslat.', 'Chyba!', MB_ICONERROR)
    else
      MessageBox(0, 'Subor neexistuje alebo sa neda otvorit.', 'Chyba!', MB_ICONERROR);

  end
  else
    MessageBox(0, 'Posielat mozes maximalne 1 subor naraz.', 'Chyba!', MB_ICONERROR);

  // let Windows know that you're done
  DragFinish( msg.WParam );
end;


procedure TForm1.Button2Click(Sender: TObject);
begin
  // Set up the starting directory to be the current one
  OpenDialog1.InitialDir := GetCurrentDir;

  OpenDialog1.Execute;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  IniFile: TIniFile;
  NazovSuboru: string;
begin
  Form2.ShowModal;
  NazovSuboru := ExtractFileDir(ParamStr(0)) + '\' + 'nastavenia.ini';

  IniFile := TIniFile.Create(NazovSuboru);
  IP := IniFile.ReadString('Adresa', 'IP', '127.0.0.1');
  PORT := IniFile.ReadInteger('Adresa', 'Port', 1234);
  PORT_SERVER := IniFile.ReadInteger('Adresa', 'Port2', 1234);
  IniFile.Free;

  IdTCPServer1.DefaultPort := PORT_SERVER;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  MessageBox(0, 'Autor: Jorg'+ #13#10 +'Email: jorg.pavol@gmail.com', 'About', MB_ICONINFORMATION);
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  IniFile : TIniFile;
  NazovSuboru: string;
begin
  //Drag and Drop files
  DragAcceptFiles( Handle, True );
  //Drag and Drop files koniec

  //Tray ikona
  with TrayIconData do
  begin
    cbSize := SizeOf(TrayIconData);
    Wnd := Handle;
    uID := 0;
    uFlags := NIF_MESSAGE + NIF_ICON + NIF_TIP;
    uCallbackMessage := WM_ICONTRAY;
    hIcon := Application.Icon.Handle;
    StrPCopy(szTip, Application.Title);
  end;

  Shell_NotifyIcon(NIM_ADD, @TrayIconData);
  //Tray ikona koniec

  NAZOV_PRIECINKU := 'income';
  if not DirectoryExists(NAZOV_PRIECINKU) then
    CreateDir(NAZOV_PRIECINKU);

  NazovSuboru := ExtractFileDir(ParamStr(0)) + '\' + 'nastavenia.ini';
  if not FileExists(NazovSuboru) then
  begin
   IniFile := TIniFile.Create(NazovSuboru);
   IniFile.WriteString('Adresa','IP','127.0.0.1');
   IniFile.WriteString('Adresa','Port','1234');
   IniFile.WriteString('Adresa','Port2','1234');
   IniFile.WriteString('Ostatne','AutoStart','nie');
   IniFile.Free;
  end;

  IniFile := TIniFile.Create(NazovSuboru);
  IP := IniFile.ReadString('Adresa', 'IP', '127.0.0.1');
  PORT := IniFile.ReadInteger('Adresa', 'Port', 1234);
  PORT_SERVER := IniFile.ReadInteger('Adresa', 'Port2', 1234);
  IniFile.Free;

  IdTCPServer1.DefaultPort := PORT;
  IdTCPServer1.Active := True;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Shell_NotifyIcon(NIM_DELETE, @TrayIconData);
end;

procedure TForm1.IdTCPClient1Disconnected(Sender: TObject);
begin
  Button1.Enabled := True;
end;

procedure TForm1.IdTCPClient1Work(ASender: TObject; AWorkMode: TWorkMode;
  AWorkCount: Int64);
var
  Velkost, VelkostOriginal, Rychlost: extended;
  Step: integer;
begin
   ProgressBar1.Max := SUBOR_VELKOST_ORIGINAL;
   Velkost := (AWorkCount / 1024);

   Step := AWorkCount - CISLO;
   ProgressBar1.StepBy(Step);

   if (CISLO > 0) then
    Rychlost := ((Step) / 1024)
   else
    Rychlost := 0.0;

   CISLO := AWorkCount;

   VelkostOriginal := (SUBOR_VELKOST_ORIGINAL / 1024);

   Label1.Caption := 'Rychlost: ' + FormatFloat('0', Rychlost) + 'kb/s    Odoslane: ' + FormatFloat('0', Velkost) + 'kb z ' + FormatFloat('0', VelkostOriginal) + 'kb';
end;

procedure TForm1.IdTCPClient1WorkBegin(ASender: TObject; AWorkMode: TWorkMode;
  AWorkCountMax: Int64);
begin
  Button1.Enabled := False;
end;

procedure TForm1.IdTCPClient1WorkEnd(ASender: TObject; AWorkMode: TWorkMode);
begin
   Button1.Enabled := True;
end;

procedure  TForm1.IdTCPServer1Work(ASender: TObject; AWorkMode: TWorkMode; AWorkCount: Int64);
begin
    Label2.Caption := 'losssssssssssssssssssl'+IntToStr(AWorkCount);
end;

procedure TForm1.IdTCPServer1Execute(AContext: TIdContext);
var
  Command: string;
  Velkost: string;
  NazovSuboru: string;
  NazovSuboruOriginal: string;
  Stream : TFileStream;
  Prepisat, Prijat: integer;
  Text: PWideChar;
begin
    Command := AContext.Connection.IOHandler.ReadLn;
    if Command = 'ZACNEM' then
    begin
       AContext.Connection.IOHandler.WriteLn('ZACNI');

       NazovSuboru := AContext.Connection.IOHandler.ReadLn;
       NazovSuboruOriginal := NazovSuboru;
       SUBOR := NazovSuboruOriginal;
       NazovSuboru := ExtractFileDir(ParamStr(0)) + '\' + NAZOV_PRIECINKU + '\' + NazovSuboru;

       Memo1.Lines.Add('[Server]Prichadza spojenie.');

       Memo1.Lines.Add('Prijat subor?' +  NazovSuboruOriginal);
       Text := PWideChar('Prijat subor?' + #13#10 + NazovSuboruOriginal);


       Prijat := MessageBox(0, Text, 'Prichadzajuce spojenie', +mb_YesNo +mb_ICONINFORMATION);
       if Prijat = 6 then
       begin

        Prepisat := 8;
        if FileExists(NazovSuboru) then
        begin
          Memo1.Lines.Add('[Server]Subor existuje, prepisat?.');
          Text := PWideChar('Prepisat subor?' + #13#10 + NazovSuboruOriginal);
          Prepisat := MessageBox(0, Text, 'Subor existuje!', +mb_YesNo +mb_ICONWARNING);
        end;

        if (Prepisat = 6) or (Prepisat = 8) then
        begin
         AContext.Connection.IOHandler.WriteLn('POKRACUJEM');

         Memo1.Lines.Add('[Server]Prijmam subor....');

         Stream := TFileStream.Create(NazovSuboru, fmCreate);
         Velkost := AContext.Connection.IOHandler.ReadLn;
         SUBOR_VELKOST_ORIGINAL := StrToInt(Velkost);

         AContext.Connection.IOHandler.OnWork := IdTCPServer1Work;

         AContext.Connection.IOHandler.ReadStream(Stream, StrToInt(Velkost), False);
         FreeAndNil(Stream);

         AContext.Connection.IOHandler.WriteLn('DONE');
         Memo1.Lines.Add('[Server]Subor ' + NazovSuboruOriginal + ' bol uspesne ulozeny.');
         PlaySound('notify.wav');
        end
        else
        begin
         AContext.Connection.IOHandler.WriteLn('ERROR');
         Memo1.Lines.Add('[Server]Subor ' + NazovSuboruOriginal + ' neprijaty.');
         AContext.Connection.Disconnect;
        end;
       end
       else
       begin
        Memo1.Lines.Add('[Server]Odmietnutie suboru.');
        AContext.Connection.IOHandler.WriteLn('NECHCEM');
       end;
   end;
   AContext.Connection.Disconnect;
end;

procedure TThreadThread.Execute;
var
  Command: string;
  NazovSuboru: string;
  NazovOdoslat: string;
  Velkost: integer;
  Stream: TFileStream;
begin
  with Form1 do
  begin
  Button1.Enabled := False;
  NazovSuboru := OpenDialog1.FileName;
  if not FileExists(NazovSuboru) then
  begin
    MessageBox(0, 'Subor neexistuje alebo a neda otvorit.', 'Chyba!', MB_ICONERROR);
    Memo1.Lines.Add('[Client]Subor neodoslany, chyba.');
  end
  else
  begin
  Stream := TFileStream.Create(NazovSuboru, fmOpenRead);
  Velkost := Stream.Size;
  Stream.Free;

  IdTCPClient1.Host := IP;
  IdTCPClient1.Port := PORT;
  Memo1.Lines.Add('[Client]Pripajam....');
  try
   IdTCPClient1.Connect;
  except
   Button1.Enabled := True;
   Memo1.Lines.Add('[Client]Neda sa pripojit, chyba.');
  end;

  IdTCPClient1.IOHandler.WriteLn('ZACNEM');
  Memo1.Lines.Add('[Client]Pripojeny.');
  Command := IdTCPClient1.IOHandler.ReadLn;
  if Command = 'ZACNI' then
  begin
    Memo1.Lines.Add('[Client]Cakam na odpoved.');
    NazovOdoslat := ExtractFilename(NazovSuboru);
    IdTCPClient1.IOHandler.WriteLn(NazovOdoslat);

    Command := IdTCPClient1.IOHandler.ReadLn;
    if Command = 'POKRACUJEM' then
    begin
      Memo1.Lines.Add('[Client]Zacinam odosielat.');
      // copy file stream to write stream
      IdTCPClient1.IOHandler.WriteLn(IntToStr(Velkost));
      IdTCPClient1.IOHandler.WriteFile(NazovSuboru);

      //making sure!
      Command := IdTCPClient1.IOHandler.ReadLn;
    end;
  end;

  IdTCPClient1.Disconnect;
  end;

  if Command = 'DONE' then
  begin
    Memo1.Lines.Add('[Client]Subor ' + NazovOdoslat + ' bol uspesne odoslany.');
    PlaySound('ringout.wav');
  end
  else if Command = 'NECHCEM' then
    Memo1.Lines.Add('[Client]Uzivatel odmietol prijatie suboru ' + NazovOdoslat + ' .')
  else
    Memo1.Lines.Add('[Client]Nastala chyba pri odosielani suboru ' + NazovOdoslat + ' .');
  Button1.Enabled := True;
  end;
end;

procedure TForm1.TrayMessage(var Msg: TMessage);
begin
  case Msg.lParam of
    WM_LBUTTONDOWN:
    begin
      if Form1.Showing then
      begin
        Form1.Hide;
      end
      else
      begin
        Form1.Show;
      end;

    end;
    WM_RBUTTONDOWN:
    begin
      Form1.Hide;
    end;
  end;
end;

end.
